=== modified file 'tests/r/subselect_no_opts.result'
--- tests/r/subselect_no_opts.result	2009-05-12 23:14:29 +0000
+++ tests/r/subselect_no_opts.result	2009-06-17 06:23:38 +0000
@@ -2,6 +2,7 @@
 Variable_name	Value
 optimizer_switch	
 set optimizer_switch='no_materialization,no_semijoin';
+# Initialise
 drop table if exists t1,t2,t3,t4,t5,t6,t7,t8,t11,t12;
 select (select 2);
 (select 2)
@@ -246,6 +247,7 @@
 a
 6
 3
+# Rewrite: select * from t3 where not exists (select b from t2 where a <> b);
 select * from t3 where a = all (select b from t2);
 a
 7
@@ -280,6 +282,7 @@
 select * from t3 where a in (select * from t2);
 ERROR 21000: Operand should contain 1 column(s)
 insert into t4 values (12,7),(1,7),(10,9),(9,6),(7,6),(3,9),(1,10);
+# empty set
 select b,max(a) as ma from t4 group by b having b < (select max(t2.a) from t2 where t2.b=t4.b);
 b	ma
 insert into t2 values (2,10);
@@ -333,8 +336,10 @@
 Warnings:
 Note	1276	Field or reference 'test.t6.clinic_uq' of SELECT #2 was resolved in SELECT #1
 Note	1003	select `test`.`t6`.`patient_uq` AS `patient_uq`,`test`.`t6`.`clinic_uq` AS `clinic_uq` from `test`.`t6` where exists(select 1 AS `Not_used` from `test`.`t7` where (`test`.`t7`.`uq` = `test`.`t6`.`clinic_uq`))
+# not unique fields
 select * from t1 where a= (select a from t2,t4 where t2.b=t4.b);
 ERROR 23000: Column 'a' in field list is ambiguous
+# different tipes & group functions
 drop table t1,t2,t3;
 CREATE TABLE t3 (a varchar(20),b char(1) NOT NULL default '0') ENGINE=MyISAM;
 INSERT INTO t3 VALUES ('W','a'),('A','c'),('J','b');
@@ -380,6 +385,7 @@
 SELECT pseudo FROM t8 WHERE pseudo=(SELECT pseudo FROM t8 WHERE pseudo LIKE '%joce%');
 ERROR 21000: Subquery returns more than 1 row
 drop table if exists t1,t2,t3,t4,t5,t6,t7,t8;
+#searchconthardwarefr3 forumconthardwarefr7
 CREATE TABLE `t1` (
 `topic` bigint NOT NULL default '0',
 `date` date NULL,
@@ -422,6 +428,7 @@
 Warnings:
 Note	1003	select 1 AS `1` from `test`.`t1` where 1
 drop table t1;
+#forumconthardwarefr7 searchconthardwarefr7
 CREATE TABLE `t1` (
 `numeropost` bigint NOT NULL auto_increment,
 `maxnumrep` int NOT NULL default '0',
@@ -494,6 +501,7 @@
 joce	40143	2002-10-22	joce	1
 joce	43506	2002-10-22	joce	0
 drop table t1,t2;
+#forumconthardwarefr7
 CREATE TABLE `t1` (
 `numeropost` bigint NOT NULL auto_increment,
 `maxnumrep` int NOT NULL default '0',
@@ -514,11 +522,13 @@
 2
 3
 drop table t1;
+#iftest
 CREATE TABLE t1 (field char(1) NOT NULL DEFAULT 'b') ENGINE=MyISAM;
 INSERT INTO t1 VALUES ();
 SELECT field FROM t1 WHERE 1=(SELECT 1 UNION ALL SELECT 1 FROM (SELECT 1) a HAVING field='b');
 ERROR 21000: Subquery returns more than 1 row
 drop table t1;
+# threadhardwarefr7
 CREATE TABLE `t1` (
 `numeropost` bigint NOT NULL default '0',
 `numreponse` int NOT NULL auto_increment,
@@ -554,6 +564,7 @@
 1
 1
 drop table t1;
+#update with subselects
 create table t1 (a int NOT NULL, b int, primary key (a)) ENGINE=MyISAM;
 create table t2 (a int NOT NULL, b int, primary key (a)) ENGINE=MyISAM;
 insert into t1 values (0, 10),(1, 11),(2, 12);
@@ -574,6 +585,7 @@
 1	21
 2	22
 drop table t1, t2;
+#delete with subselects
 create table t1 (a int NOT NULL, b int, primary key (a)) ENGINE=MyISAM;
 create table t2 (a int NOT NULL, b int, primary key (a)) ENGINE=MyISAM;
 insert into t1 values (0, 10),(1, 11),(2, 12);
@@ -596,6 +608,7 @@
 0	10
 1	11
 drop table t1, t2;
+#multi-delete with subselects
 create table t11 (a int NOT NULL, b int, primary key (a)) ENGINE=MyISAM;
 create table t12 (a int NOT NULL, b int, primary key (a)) ENGINE=MyISAM;
 create table t2 (a int NOT NULL, b int, primary key (a)) ENGINE=MyISAM;
@@ -626,6 +639,7 @@
 22	11
 33	10
 drop table t11, t12, t2;
+#insert with subselects
 CREATE TABLE t1 (x int) ENGINE=MyISAM;
 create table t2 (a int) ENGINE=MyISAM;
 create table t3 (b int) ENGINE=MyISAM;
@@ -652,6 +666,7 @@
 2
 3
 3
+# After this, only data based on old t1 records should have been added.
 INSERT INTO t1 (x) select (SELECT SUM(x)+2 FROM t1) FROM t2;
 select * from t1;
 x
@@ -673,7 +688,12 @@
 11
 11
 2
+#
+#TODO: should be uncommented after bug 380 fix pushed
+#INSERT INTO t1 (x) SELECT (SELECT SUM(a)+b FROM t2) from t3;
+#select * from t1;
 drop table t1, t2, t3;
+#replace with subselects
 CREATE TABLE t1 (x int not null, y int, primary key (x)) ENGINE=MyISAM;
 create table t2 (a int) ENGINE=MyISAM;
 create table t3 (a int) ENGINE=MyISAM;
@@ -762,6 +782,7 @@
 UPDATE t2 SET id=(SELECT * FROM t1);
 ERROR 21000: Subquery returns more than 1 row
 drop table t2, t1;
+#NULL test
 create table t1 (a int) ENGINE=MyISAM;
 insert into t1 values (1),(2),(3);
 select 1 IN (SELECT * from t1);
@@ -876,6 +897,9 @@
 4.5
 NULL
 drop table t1;
+#
+# Null with keys
+#
 CREATE TABLE t1 (a int NOT NULL default '0', PRIMARY KEY  (a)) ENGINE=MyISAM;
 CREATE TABLE t2 (a int default '0', INDEX (a)) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1),(2),(3),(4);
@@ -908,6 +932,38 @@
 Warnings:
 Note	1003	select `test`.`t1`.`a` AS `a`,<in_optimizer>(`test`.`t1`.`a`,<exists>(select 1 AS `Not_used` from `test`.`t2` join `test`.`t3` where ((`test`.`t3`.`a` = `test`.`t2`.`a`) and ((<cache>(`test`.`t1`.`a`) = `test`.`t2`.`a`) or isnull(`test`.`t2`.`a`))) having <is_not_null_test>(`test`.`t2`.`a`))) AS `t1.a in (select t2.a from t2,t3 where t3.a=t2.a)` from `test`.`t1`
 drop table t1,t2,t3;
+#LIMIT is not supported now
+#create table t1 (a float) ENGINE=MyISAM;
+#-- error 1235
+#select 10.5 IN (SELECT * from t1 LIMIT 1);
+#-- error 1235
+#select 10.5 IN (SELECT * from t1 LIMIT 1 UNION SELECT 1.5);
+#drop table t1;
+#
+#create table t1 (a int, b int, c varchar(10)) ENGINE=MyISAM;
+#create table t2 (a int) ENGINE=MyISAM;
+#insert into t1 values (1,2,'a'),(2,3,'b'),(3,4,'c');
+#insert into t2 values (1),(2),(NULL);
+#select a, (select a,b,c from t1 where t1.a=t2.a) = ROW(a,2,'a'),(select c from t1 where a=t2.a)  from t2;
+#select a, (select a,b,c from t1 where t1.a=t2.a) = ROW(a,3,'b'),(select c from t1 where a=t2.a) from t2;
+#select a, (select a,b,c from t1 where t1.a=t2.a) = ROW(a,4,'c'),(select c from t1 where a=t2.a) from t2;
+#drop table t1,t2;
+#
+#create table t1 (a int, b real, c varchar(10)) ENGINE=MyISAM;
+#insert into t1 values (1, 1, 'a'), (2,2,'b'), (NULL, 2, 'b');
+#select ROW(1, 1, 'a') IN (select a,b,c from t1);
+#select ROW(1, 2, 'a') IN (select a,b,c from t1);
+#select ROW(1, 1, 'a') IN (select b,a,c from t1);
+#select ROW(1, 1, 'a') IN (select a,b,c from t1 where a is not null);
+#select ROW(1, 2, 'a') IN (select a,b,c from t1 where a is not null);
+#select ROW(1, 1, 'a') IN (select b,a,c from t1 where a is not null);
+#select ROW(1, 1, 'a') IN (select a,b,c from t1 where c='b' or c='a');
+#select ROW(1, 2, 'a') IN (select a,b,c from t1 where c='b' or c='a');
+#select ROW(1, 1, 'a') IN (select b,a,c from t1 where c='b' or c='a');
+#-- error 1235
+#select ROW(1, 1, 'a') IN (select b,a,c from t1 limit 2);
+#drop table t1;
+#test of uncacheable subqueries
 CREATE TABLE t1 (a int) ENGINE=MyISAM;
 EXPLAIN EXTENDED SELECT (SELECT RAND() FROM t1) FROM t1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
@@ -1011,8 +1067,14 @@
 Warnings:
 Note	1003	select `test`.`t1`.`a` AS `a`,(select (select rand() AS `rand()` from `test`.`t1` limit 1) AS `(select rand() from t1 limit 1)` from `test`.`t1` limit 1) AS `(select (select rand() from t1 limit 1)  from t1 limit 1)` from `test`.`t1`
 drop table t1;
+#
+# error in IN
+#
 select t1.Continent, t2.Name, t2.Population from t1 LEFT JOIN t2 ON t1.Code = t2.Country  where t2.Population IN (select max(t2.Population) AS Population from t2, t1 where t2.Country = t1.Code group by Continent);
 ERROR 42S02: Table 'test.t1' doesn't exist
+#
+# complex subquery
+#
 CREATE TABLE t1 (
 ID int NOT NULL auto_increment,
 name char(35) NOT NULL default '',
@@ -1048,6 +1110,9 @@
 Continent	Name	Population
 Oceania	Sydney	3276207
 drop table t1, t2;
+#
+# constants in IN
+#
 CREATE TABLE `t1` (
 `id` bigint NOT NULL auto_increment,
 `pseudo` varchar(35) NOT NULL default '',
@@ -1088,6 +1153,9 @@
 i
 3
 drop table t1;
+#
+# Multi update test
+#
 CREATE TABLE t1 (
 id int default NULL
 ) ENGINE=MyISAM;
@@ -1105,12 +1173,18 @@
 2	lenka
 1	lenka
 drop table t1,t2;
+#
+# correct NULL in <CONSTANT> IN (SELECT ...)
+#
 create table t1 (a int, unique index indexa (a)) ENGINE=MyISAM;
 insert into t1 values (-1), (-4), (-2), (NULL);
 select -10 IN (select a from t1 FORCE INDEX (indexa));
 -10 IN (select a from t1 FORCE INDEX (indexa))
 NULL
 drop table t1;
+#
+# Test optimization for sub selects
+#
 create table t1 (id int not null auto_increment primary key, salary int, key(salary)) ENGINE=MyISAM;
 insert into t1 (salary) values (100),(1000),(10000),(10),(500),(5000),(50000);
 explain extended SELECT id FROM t1 where salary = (SELECT MAX(salary) FROM t1);
@@ -1134,6 +1208,9 @@
 SELECT DISTINCT REF_ID FROM t1 WHERE ID= (SELECT DISTINCT REF_ID FROM t1 WHERE ID=2);
 REF_ID
 DROP TABLE t1;
+#
+# uninterruptable update
+#
 create table t1 (a int, b int) ENGINE=MyISAM;
 create table t2 (a int, b int) ENGINE=MyISAM;
 insert into t1 values (1,0), (2,0), (3,0);
@@ -1147,6 +1224,9 @@
 2	NULL
 3	1
 drop table t1, t2;
+#
+# reduced subselect in ORDER BY & GROUP BY clauses
+#
 CREATE TABLE `t1` (
 `id` bigint NOT NULL auto_increment,
 `pseudo` varchar(35) NOT NULL default '',
@@ -1164,6 +1244,9 @@
 (SELECT 1 as a) UNION (SELECT 1) ORDER BY (SELECT a+0);
 a
 1
+#
+# IN subselect optimization test
+#
 create table t1 (a int not null, b int, primary key (a)) ENGINE=MyISAM;
 create table t2 (a int not null, primary key (a)) ENGINE=MyISAM;
 create table t3 (a int not null, b int, primary key (a)) ENGINE=MyISAM;
@@ -1207,6 +1290,7 @@
 create table t2 (a int, index a (a)) ENGINE=MyISAM;
 create table t3 (a int, b int, index a (a)) ENGINE=MyISAM;
 insert into t1 values (1,10), (2,20), (3,30), (4,40);
+# making table large enough
 insert into t2 values (2), (3), (4), (5);
 insert into t3 values (10,3), (20,4), (30,5);
 select * from t2 where t2.a in (select a from t1);
@@ -1258,6 +1342,9 @@
 Warnings:
 Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(<index_lookup>(<cache>(`test`.`t2`.`a`) in t1 on a where ((`test`.`t1`.`b` <> 30) and (<cache>(`test`.`t2`.`a`) = `test`.`t1`.`a`)))))
 drop table t1, t2, t3;
+#
+# alloc_group_fields() working
+#
 create table t1 (a int, b int) ENGINE=MyISAM;
 create table t2 (a int, b int) ENGINE=MyISAM;
 create table t3 (a int, b int) ENGINE=MyISAM;
@@ -1270,6 +1357,9 @@
 2	2
 1	2
 drop table t1,t2,t3;
+#
+# aggregate functions in HAVING test
+#
 create table t1 (s1 int) ENGINE=MyISAM;
 create table t2 (s1 int) ENGINE=MyISAM;
 insert into t1 values (1);
@@ -1278,6 +1368,10 @@
 s1
 1
 drop table t1,t2;
+#
+# update subquery with wrong field (to force name resolving
+# in UPDATE name space)
+#
 create table t1 (s1 int) ENGINE=MyISAM;
 create table t2 (s1 int) ENGINE=MyISAM;
 insert into t1 values (1);
@@ -1285,6 +1379,20 @@
 update t1 set  s1 = s1 + 1 where 1 = (select x.s1 as A from t2 WHERE t2.s1 > t1.s1 order by A);
 ERROR 42S22: Unknown column 'x.s1' in 'field list'
 DROP TABLE t1, t2;
+#
+# collation test
+#
+#CREATE TABLE t1 (s1 CHAR(5) COLLATE latin1_german1_ci,
+#                 s2 CHAR(5) COLLATE latin1_swedish_ci) ENGINE=MyISAM;
+#INSERT INTO t1 VALUES ('z','?');
+#-- error 1267
+#select * from t1 where s1 > (select max(s2) from t1);
+#-- error 1267
+#select * from t1 where s1 > any (select max(s2) from t1);
+#drop table t1;
+#
+# aggregate functions reinitialization
+#
 create table t1(toid int,rd int) ENGINE=MyISAM;
 create table t2(userid int,pmnew int,pmtotal int) ENGINE=MyISAM;
 insert into t2 values(1,0,0),(2,0,0);
@@ -1294,6 +1402,9 @@
 1	0	0	9	3
 2	0	0	4	2
 drop table t1, t2;
+#
+# row union
+#
 create table t1 (s1 char(5)) ENGINE=MyISAM;
 select (select 'a','b' from t1 union select 'a','b' from t1) from t1;
 ERROR 21000: Operand should contain 1 column(s)
@@ -1310,6 +1421,9 @@
 s1
 tttt
 drop table t1;
+#
+# IN optimisation test results
+#
 create table t1 (s1 char(5), index s1(s1)) ENGINE=MyISAM;
 create table t2 (s1 char(5), index s1(s1)) ENGINE=MyISAM;
 insert into t1 values ('a1'),('a2'),('a3');
@@ -1359,6 +1473,9 @@
 Warnings:
 Note	1003	select `test`.`t1`.`s1` AS `s1`,(not(<in_optimizer>(`test`.`t1`.`s1`,<exists>(<index_lookup>(<cache>(`test`.`t1`.`s1`) in t2 on s1 checking NULL where (`test`.`t2`.`s1` < 'a2') having trigcond(<is_not_null_test>(`test`.`t2`.`s1`))))))) AS `s1 NOT IN (SELECT s1 FROM t2 WHERE s1 < 'a2')` from `test`.`t1`
 drop table t1,t2;
+#
+# correct ALL optimisation
+#
 create table t2 (a int, b int) ENGINE=MyISAM;
 create table t3 (a int) ENGINE=MyISAM;
 insert into t3 values (6),(7),(3);
@@ -1432,6 +1549,9 @@
 2	SUBQUERY	t2	system	NULL	NULL	NULL	NULL	0	0.00	const row not found
 Warnings:
 Note	1003	select `test`.`t3`.`a` AS `a` from `test`.`t3` where 0
+#
+# optimized static ALL/ANY with grouping
+#
 insert into t2 values (2,2), (2,1), (3,3), (3,1);
 select * from t3 where a > all (select max(b) from t2 group by a);
 a
@@ -1444,6 +1564,9 @@
 Warnings:
 Note	1003	select `test`.`t3`.`a` AS `a` from `test`.`t3` where <not>((`test`.`t3`.`a` <= <max>(select max(`test`.`t2`.`b`) AS `max(b)` from `test`.`t2` group by `test`.`t2`.`a`)))
 drop table t2, t3;
+#
+# correct used_tables()
+#
 CREATE TABLE `t1` ( `id` bigint NOT NULL auto_increment, `taskid` bigint NOT NULL default '0', `dbid` int NOT NULL default '0', `create_date` datetime, `last_update` datetime, PRIMARY KEY  (`id`)) ENGINE=MyISAM AUTO_INCREMENT=3 ;
 INSERT INTO `t1` (`id`, `taskid`, `dbid`, `create_date`,`last_update`) VALUES (1, 1, 15, '2003-09-29 10:31:36', '2003-09-29 10:31:36'), (2, 1, 21, now(), now());
 CREATE TABLE `t2` (`db_id` int NOT NULL auto_increment,`name` varchar(200) NOT NULL default '',`primary_uid` int NOT NULL default '0',`secondary_uid` int NOT NULL default '0',PRIMARY KEY  (`db_id`),UNIQUE KEY `name_2` (`name`)) ENGINE=MyISAM AUTO_INCREMENT=2147483647;
@@ -1462,6 +1585,9 @@
 -1	Valid
 -1	Valid 2
 drop table t1,t2,t3,t4;
+#
+# cardinality check
+#
 CREATE TABLE t1 (id int default NULL) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1),(5);
 CREATE TABLE t2 (id int default NULL) ENGINE=MyISAM;
@@ -1469,6 +1595,9 @@
 select * from t1 where (1,2,6) in (select * from t2);
 ERROR 21000: Operand should contain 3 column(s)
 DROP TABLE t1,t2;
+#
+# optimized ALL/ANY with union
+#
 create table t1 (s1 char) ENGINE=MyISAM;
 insert into t1 values ('e');
 select * from t1 where 'f' > any (select s1 from t1);
@@ -1486,6 +1615,9 @@
 Warnings:
 Note	1003	select 'e' AS `s1` from `test`.`t1` where 1
 drop table t1;
+#
+# filesort in subquery (restoring join_tab)
+#
 CREATE TABLE t1 (number char(11) NOT NULL default '') ENGINE=MyISAM;
 INSERT INTO t1 VALUES ('69294728265'),('18621828126'),('89356874041'),('95895001874');
 CREATE TABLE t2 (code char(5) NOT NULL default '',UNIQUE KEY code (code)) ENGINE=MyISAM;
@@ -1497,6 +1629,9 @@
 89356874041	NULL
 95895001874	NULL
 drop table t1, t2;
+#
+# unresolved field error
+#
 create table t1 (s1 int) ENGINE=MyISAM;
 create table t2 (s1 int) ENGINE=MyISAM;
 select * from t1 where (select count(*) from t2 where t1.s2) = 1;
@@ -1506,6 +1641,9 @@
 select count(*) from t2 group by t1.s2;
 ERROR 42S22: Unknown column 't1.s2' in 'group statement'
 drop table t1, t2;
+#
+# fix_fields() in add_ref_to_table_cond()
+#
 CREATE TABLE t1(COLA FLOAT NOT NULL,COLB FLOAT NOT NULL,COLC VARCHAR(20) DEFAULT NULL,PRIMARY KEY (COLA, COLB)) ENGINE=MyISAM;
 CREATE TABLE t2(COLA FLOAT NOT NULL,COLB FLOAT NOT NULL,COLC CHAR(1) NOT NULL,PRIMARY KEY (COLA)) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1,1,'1A3240'), (1,2,'4W2365');
@@ -1523,6 +1661,9 @@
 4
 5
 DROP TABLE t1;
+#
+# Bug 2479
+#
 CREATE TABLE `t1` (
 `id` int NOT NULL auto_increment,
 `id_cns` int NOT NULL default '0',
@@ -1547,6 +1688,9 @@
 50	1990	0
 51	1990	NULL
 DROP TABLE t1, t2;
+#
+# GLOBAL LIMIT
+#
 create table t1 (a int) ENGINE=MyISAM;
 insert into t1 values (1), (2), (3);
 SET SQL_SELECT_LIMIT=1;
@@ -1558,6 +1702,9 @@
 1
 SET SQL_SELECT_LIMIT=default;
 drop table t1;
+#
+# Bug #3118: subselect + order by
+#
 CREATE TABLE t1 (a int, b int, INDEX (a)) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1, 1), (1, 2), (1, 3);
 SELECT * FROM t1 WHERE a = (SELECT MAX(a) FROM t1 WHERE a = 1) ORDER BY b;
@@ -1566,12 +1713,17 @@
 1	2
 1	3
 DROP TABLE t1;
+# Item_cond fix field
+#
 create table t1(val varchar(10)) ENGINE=MyISAM;
 insert into t1 values ('aaa'), ('bbb'),('eee'),('mmm'),('ppp');
 select count(*) from t1 as w1 where w1.val in (select w2.val from t1 as w2 where w2.val like 'm%') and w1.val in (select w3.val from t1 as w3 where w3.val like 'e%');
 count(*)
 0
 drop table t1;
+#
+# ref_or_null replacing with ref
+#
 create table t1 (id int not null, text varchar(20) not null default '', primary key (id)) ENGINE=MyISAM;
 insert into t1 (id, text) values (1, 'text1'), (2, 'text2'), (3, 'text3'), (4, 'text4'), (5, 'text5'), (6, 'text6'), (7, 'text7'), (8, 'text8'), (9, 'text9'), (10, 'text10'), (11, 'text11'), (12, 'text12');
 select * from t1 where id not in (select id from t1 where id < 8);
@@ -1628,6 +1780,9 @@
 Warnings:
 Note	1003	select `test`.`a`.`id` AS `id`,`test`.`a`.`text` AS `text`,`test`.`b`.`id` AS `id`,`test`.`b`.`text` AS `text`,`test`.`c`.`id` AS `id`,`test`.`c`.`text` AS `text` from `test`.`t1` `a` left join `test`.`t2` `b` on(((`test`.`b`.`id` = `test`.`a`.`id`) or isnull(`test`.`b`.`id`))) join `test`.`t1` `c` where (if(isnull(`test`.`b`.`id`),1000,`test`.`b`.`id`) = `test`.`c`.`id`)
 drop table t1,t2;
+#
+# Static tables & rund() in subqueries
+#
 create table t1 (a int) ENGINE=MyISAM;
 insert into t1 values (1);
 explain select benchmark(1000, (select a from t1 where a=rand()));
@@ -1635,12 +1790,18 @@
 1	PRIMARY	NULL	NULL	NULL	NULL	NULL	NULL	NULL	No tables used
 2	SUBQUERY	t1	system	NULL	NULL	NULL	NULL	1	
 drop table t1;
+#
+# bug 3188
+#
 create table t1(id int) ENGINE=MyISAM;
 create table t2(id int) ENGINE=MyISAM;
 create table t3(flag int) ENGINE=MyISAM;
 select (select * from t3 where id not null) from t1, t2;
 ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your Drizzle server version for the right syntax to use near 'null) from t1, t2' at line 1
 drop table t1,t2,t3;
+#
+# aggregate functions (Bug #3505)
+#
 CREATE TABLE t1 (id INT) ENGINE=MyISAM;
 CREATE TABLE t2 (id INT) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1), (2);
@@ -1662,6 +1823,9 @@
 1	1
 2	0
 DROP TABLE t1,t2;
+#
+# ALL/ANY test
+#
 CREATE TABLE t1 ( a int, b int ) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1,1),(2,2),(3,3);
 SELECT a FROM t1 WHERE a > ANY ( SELECT a FROM t1 WHERE b = 2 );
@@ -1706,6 +1870,7 @@
 a
 1
 3
+# with index
 ALTER TABLE t1 ADD INDEX (a);
 SELECT a FROM t1 WHERE a > ANY ( SELECT a FROM t1 WHERE b = 2 );
 a
@@ -1749,6 +1914,7 @@
 a
 1
 3
+# having clause test
 SELECT a FROM t1 WHERE a > ANY (SELECT a FROM t1 HAVING a = 2);
 a
 3
@@ -1791,6 +1957,7 @@
 a
 1
 3
+# union test
 SELECT a FROM t1 WHERE a > ANY (SELECT a FROM t1 WHERE b = 2 UNION SELECT a FROM t1 WHERE b = 2);
 a
 3
@@ -1833,6 +2000,7 @@
 a
 1
 3
+# union + having test
 SELECT a FROM t1 WHERE a > ANY (SELECT a FROM t1 HAVING a = 2 UNION SELECT a FROM t1 HAVING a = 2);
 a
 3
@@ -1875,6 +2043,8 @@
 a
 1
 3
+# row tests
+# < > >= <= and = ALL/ <> ANY do not support row operation
 SELECT a FROM t1 WHERE (1,2) > ANY (SELECT a FROM t1 WHERE b = 2);
 ERROR 21000: Operand should contain 1 column(s)
 SELECT a FROM t1 WHERE a > ANY (SELECT a,2 FROM t1 WHERE b = 2);
@@ -1891,6 +2061,7 @@
 ERROR 21000: Operand should contain 1 column(s)
 SELECT a FROM t1 WHERE (1,2) <> ANY (SELECT a,2 FROM t1 WHERE b = 2);
 ERROR 21000: Operand should contain 1 column(s)
+# following should be converted to IN
 SELECT a FROM t1 WHERE (1,2) = ANY (SELECT a FROM t1 WHERE b = 2);
 ERROR 21000: Operand should contain 2 column(s)
 SELECT a FROM t1 WHERE a = ANY (SELECT a,2 FROM t1 WHERE b = 2);
@@ -1934,6 +2105,7 @@
 a
 1
 3
+# without optimisation
 SELECT a FROM t1 WHERE a > ANY (SELECT a FROM t1 WHERE b = 2 group by a);
 a
 3
@@ -1976,6 +2148,7 @@
 a
 1
 3
+# without optimisation + having
 SELECT a FROM t1 WHERE a > ANY (SELECT a FROM t1 group by a HAVING a = 2);
 a
 3
@@ -2018,6 +2191,7 @@
 a
 1
 3
+# EXISTS in string contence
 SELECT concat(EXISTS(SELECT a FROM t1 WHERE b = 2 and a.a > t1.a), '-') from t1 a;
 concat(EXISTS(SELECT a FROM t1 WHERE b = 2 and a.a > t1.a), '-')
 0-
@@ -2124,6 +2298,9 @@
 1
 3
 DROP TABLE t1;
+#
+# SELECT(EXISTS * ...)optimisation
+#
 create table t1 (a int, b int) ENGINE=MyISAM;
 insert into t1 values (1,2),(3,4);
 select * from t1 up where exists (select * from t1 where t1.a=up.a);
@@ -2138,6 +2315,9 @@
 Note	1276	Field or reference 'test.up.a' of SELECT #2 was resolved in SELECT #1
 Note	1003	select `test`.`up`.`a` AS `a`,`test`.`up`.`b` AS `b` from `test`.`t1` `up` where exists(select 1 AS `Not_used` from `test`.`t1` where (`test`.`t1`.`a` = `test`.`up`.`a`))
 drop table t1;
+#
+# Bug #4102: subselect in HAVING
+#
 CREATE TABLE t1 (t1_a int) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1);
 CREATE TABLE t2 (t2_a int, t2_b int, PRIMARY KEY (t2_a, t2_b)) ENGINE=MyISAM;
@@ -2147,6 +2327,9 @@
 t1_a	t2_a	t2_b
 1	1	2
 DROP TABLE t1, t2;
+#
+# Test problem with NULL and derived tables (Bug #4097)
+#
 CREATE TABLE t1 (id int default NULL,name varchar(10) default NULL) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1,'Tim'),(2,'Rebecca'),(3,NULL);
 CREATE TABLE t2 (id int default NULL, pet varchar(10) default NULL) ENGINE=MyISAM;
@@ -2157,6 +2340,9 @@
 2	Rebecca	2	Spot
 3	NULL	3	Felix
 drop table t1,t2;
+#
+# Aggregate function comparation with ALL/ANY/SOME subselect
+#
 CREATE TABLE `t1` ( `a` int default NULL) ENGINE=MyISAM;
 insert into t1 values (1);
 CREATE TABLE `t2` ( `b` int default NULL, `a` int default NULL) ENGINE=MyISAM;
@@ -2165,6 +2351,9 @@
 a	C
 1	1
 drop table t1,t2;
+#
+# BUG#5003 - like in subselect
+#
 CREATE TABLE t1(`IZAVORGANG_ID` VARCHAR(11) COLLATE utf8_bin,`KUERZEL` VARCHAR(10) COLLATE utf8_bin,`IZAANALYSEART_ID` VARCHAR(11) COLLATE utf8_bin,`IZAPMKZ_ID` VARCHAR(11) COLLATE utf8_bin) ENGINE=MyISAM;
 CREATE INDEX AK01IZAVORGANG ON t1(izaAnalyseart_id,Kuerzel);
 INSERT INTO t1(`IZAVORGANG_ID`,`KUERZEL`,`IZAANALYSEART_ID`,`IZAPMKZ_ID`)VALUES('D0000000001','601','D0000000001','I0000000001');
@@ -2175,6 +2364,9 @@
 IZAVORGANG_ID
 D0000000001
 drop table t1;
+#
+# Optimized IN with compound index
+#
 CREATE TABLE `t1` ( `aid` int NOT NULL default '0', `bid` int NOT NULL default '0', PRIMARY KEY  (`aid`,`bid`)) ENGINE=MyISAM;
 CREATE TABLE `t2` ( `aid` int NOT NULL default '0', `bid` int NOT NULL default '0', PRIMARY KEY  (`aid`,`bid`)) ENGINE=MyISAM;
 insert into t1 values (1,1),(1,2),(2,1),(2,2);
@@ -2196,6 +2388,9 @@
 1	1
 2	1
 drop table t1,t2;
+#
+# resolving fields of grouped outer SELECT
+#
 CREATE TABLE t1 (howmanyvalues bigint, avalue int) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1, 1),(2, 1),(2, 2),(3, 1),(3, 2),(3, 3),(4, 1),(4, 2),(4, 3),(4, 4);
 SELECT howmanyvalues, count(*) from t1 group by howmanyvalues;
@@ -2234,6 +2429,10 @@
 select  (select b.x from t1 as b where b.x=a.x) from t1 as a where a.x=2 group by a.x;
 (select b.x from t1 as b where b.x=a.x)
 drop table t1;
+#
+# Test of correct maybe_null flag returning by subquwery for temporary table
+# creation
+#
 CREATE TABLE `t1` ( `master` int NOT NULL default '0', `map` int NOT NULL default '0', `slave` int NOT NULL default '0', `access` int NOT NULL default '0', UNIQUE KEY `access_u` (`master`,`map`,`slave`)) ENGINE=MyISAM;
 INSERT INTO `t1` VALUES (1,0,0,700),(1,1,1,400),(1,5,5,400),(1,12,12,400),(1,12,32,400),(4,12,32,400);
 CREATE TABLE `t2` ( `id` int NOT NULL default '0', `pid` int NOT NULL default '0', `map` int NOT NULL default '0', `level` int NOT NULL default '0', `title` varchar(255) default NULL, PRIMARY KEY  (`id`,`pid`,`map`), KEY `level` (`level`), KEY `id` (`id`,`map`)) ENGINE=MyISAM ;
@@ -2245,7 +2444,13 @@
 700
 NULL
 drop tables t1,t2;
+#
+# Subselect in non-select command just after connection
+#
 set @got_val= (SELECT 1 FROM (SELECT 'A' as my_col) as T1 ) ;
+#
+# primary query with temporary table and subquery with groupping
+#
 create table t1 (a int, b int) ENGINE=MyISAM;
 create table t2 (a int, b int) ENGINE=MyISAM;
 insert into t1 values (1,1),(1,2),(1,3),(2,4),(2,5);
@@ -2258,11 +2463,17 @@
 2	4	NULL
 2	5	NULL
 drop table t1, t2;
+#
+# Equal operation under row and empty subquery
+#
 create table t1 (s1 int,s2 int) ENGINE=MyISAM;
 insert into t1 values (20,15);
 select * from t1 where  (('a',null) <=> (select 'a',s2 from t1 where s1 = 0));
 s1	s2
 drop table t1;
+#
+# ALL/ANY with NULL
+#
 create table t1 (s1 int) ENGINE=MyISAM;
 insert into t1 values (1),(null);
 select * from t1 where s1 < all (select s1 from t1);
@@ -2272,6 +2483,9 @@
 1	0
 NULL	NULL
 drop table t1;
+#
+# reference on changable fields from subquery
+#
 CREATE TABLE t1 (
 Code char(3) NOT NULL default '',
 Name char(52) NOT NULL default '',
@@ -2300,6 +2514,10 @@
 c
 Oceania
 drop table t1;
+#
+# Test for BUG#7885: Server crash when 'any' subselect compared to
+# non-existant field.
+#
 create table t1 (a1 int) ENGINE=MyISAM;
 create table t2 (b1 int) ENGINE=MyISAM;
 select * from t1 where a2 > any(select b1 from t2);
@@ -2307,6 +2525,9 @@
 select * from t1 where a1 > any(select b1 from t2);
 a1
 drop table t1,t2;
+#
+# Comparison subquery with * and row
+#
 create table t1 (a integer, b integer) ENGINE=MyISAM;
 select (select * from t1) = (select 1,2);
 (select * from t1) = (select 1,2)
@@ -2314,6 +2535,7 @@
 select (select 1,2) = (select * from t1);
 (select 1,2) = (select * from t1)
 NULL
+# queries whih can be converted to IN
 select  row(1,2) = ANY (select * from t1);
 row(1,2) = ANY (select * from t1)
 0
@@ -2321,6 +2543,9 @@
 row(1,2) != ALL (select * from t1)
 1
 drop table t1;
+#
+# Comparison subquery and row with nested rows
+#
 create table t1 (a integer, b integer) ENGINE=MyISAM;
 select row(1,(2,2)) in (select * from t1 );
 ERROR 21000: Operand should contain 2 column(s)
@@ -2329,6 +2554,9 @@
 select (select * from t1) = row(1,(2,2));
 ERROR 21000: Operand should contain 1 column(s)
 drop table t1;
+#
+# Forward reference detection
+#
 create  table t1 (a integer);
 insert into t1 values (1);
 select 1 = ALL (select 1 from t1 where 1 = xx ), 1 as xx ;
@@ -2341,6 +2569,9 @@
 select 1 = ALL (select 1 from t1 where 1 = xx ), 1 as xx;
 ERROR 42S22: Reference 'xx' not supported (forward reference in item list)
 drop table t1;
+#
+# Test for BUG#8218
+#
 CREATE TABLE t1 (
 categoryId int NOT NULL,
 courseId int NOT NULL,
@@ -2440,6 +2671,9 @@
 1	5141	12	group2	12	group2	5	1	2	88	Oct04
 1	5141	12	group2	12	group2	5	1	2	89	Oct04
 drop table t1, t2, t3, t4, t5;
+#
+# Transformation in left expression of subquery (BUG#8888)
+#
 create table t1 (a int) ENGINE=MyISAM;
 insert into t1 values (1), (2), (3);
 SELECT 1 FROM t1 WHERE (SELECT 1) in (SELECT 1);
@@ -2448,6 +2682,9 @@
 1
 1
 drop table t1;
+#
+# single row subqueries and row operations (code covarage improvement)
+#
 create table t1 (a int, b int) ENGINE=MyISAM;
 insert into t1 values (1,2);
 select 1 = (select * from t1);
@@ -2463,12 +2700,38 @@
 select (select * from t1) = (1,2,3);
 ERROR 21000: Operand should contain 2 column(s)
 drop table t1;
+#
+# Item_int_with_ref check (BUG#10020)
+#
+#CREATE TABLE `t1` (
+#  `itemid` bigint NOT NULL auto_increment,
+#  `sessionid` bigint default NULL,
+#  `time` int NOT NULL default '0',
+#  `data` text collate latin1_general_ci NOT NULL,
+#  PRIMARY KEY  (`itemid`)
+#);
+#INSERT INTO `t1` VALUES (1, 1, 1, '');
+#CREATE TABLE `t2` (
+#  `sessionid` bigint NOT NULL auto_increment,
+#  `pid` int NOT NULL default '0',
+#  `date` int NOT NULL default '0',
+#  `ip` varchar(15) collate latin1_general_ci NOT NULL default '',
+#  PRIMARY KEY  (`sessionid`)
+#);
+#INSERT INTO `t2` VALUES (1, 1, 1, '10.10.10.1');
+#SELECT s.ip, count( e.itemid ) FROM `t1` e JOIN t2 s ON s.sessionid = e.sessionid WHERE e.sessionid = ( SELECT sessionid FROM t2 ORDER BY sessionid DESC LIMIT 1 ) GROUP BY s.ip HAVING count( e.itemid ) >0 LIMIT 0 , 30;
+#drop tables t1,t2;
+# BUG#11821 : Select from subselect using aggregate function on an enum
+# segfaults:
 create table t1 (fld enum('0','1')) ENGINE=MyISAM;
 insert into t1 values ('1');
 select * from (select max(fld) from t1) as foo;
 max(fld)
 1
 drop table t1;
+#
+# Bug #11867: queries with ROW(,elems>) IN (SELECT DISTINCT <cols> FROM ...)
+#
 CREATE TABLE t1 (one int, two int, flag char(1)) ENGINE=MyISAM;
 CREATE TABLE t2 (one int, two int, flag char(1)) ENGINE=MyISAM;
 INSERT INTO t1 VALUES(1,2,'Y'),(2,3,'Y'),(3,4,'Y'),(5,6,'N'),(7,8,'N');
@@ -2553,12 +2816,18 @@
 Warnings:
 Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two`,<in_optimizer>((`test`.`t1`.`one`,`test`.`t1`.`two`),<exists>(select `test`.`t2`.`one` AS `one`,`test`.`t2`.`two` AS `two` from `test`.`t2` where (`test`.`t2`.`flag` = '0') group by `test`.`t2`.`one`,`test`.`t2`.`two` having (trigcond(((<cache>(`test`.`t1`.`one`) = `test`.`t2`.`one`) or isnull(`test`.`t2`.`one`))) and trigcond(((<cache>(`test`.`t1`.`two`) = `test`.`t2`.`two`) or isnull(`test`.`t2`.`two`))) and trigcond(<is_not_null_test>(`test`.`t2`.`one`)) and trigcond(<is_not_null_test>(`test`.`t2`.`two`))))) AS `test` from `test`.`t1`
 DROP TABLE t1,t2;
+#
+# Bug #12392: where cond with IN predicate for rows and NULL values in table 
+#
 CREATE TABLE t1 (a char(5), b char(5)) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (NULL,'aaa'), ('aaa','aaa');
 SELECT * FROM t1 WHERE (a,b) IN (('aaa','aaa'), ('aaa','bbb'));
 a	b
 aaa	aaa
 DROP TABLE t1;
+#
+# Bug #11479: subquery over left join with an empty inner table 
+#
 CREATE TABLE t1 (a int) ENGINE=MyISAM;
 CREATE TABLE t2 (a int, b int) ENGINE=MyISAM;
 CREATE TABLE t3 (b int NOT NULL) ENGINE=MyISAM;
@@ -2576,6 +2845,10 @@
 3
 4
 DROP TABLE t1,t2,t3;
+#
+# Bug#18503: Queries with a quantified subquery returning empty set may
+# return a wrong result. 
+#
 CREATE TABLE t1 (f1 INT) ENGINE=MyISAM;
 CREATE TABLE t2 (f2 INT) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1);
@@ -2591,6 +2864,7 @@
 f1
 1
 DROP TABLE t1, t2;
+# BUG#20975 Wrong query results for subqueries within NOT
 create table t1 (s1 char) ENGINE=MyISAM;
 insert into t1 values (1),(2);
 select * from t1 where (s1 < any (select s1 from t1));
@@ -2618,6 +2892,9 @@
 s1
 2
 drop table t1;
+#
+# Bug #16255: Subquery in where
+#
 create table t1 (
 retailerID varchar(8) NOT NULL,
 statusID   int NOT NULL,
@@ -2640,6 +2917,10 @@
 0048	1	2006-01-06 12:37:50
 0059	1	2006-01-06 12:37:50
 drop table t1;
+#
+# Bug #21180: Subselect with index for both WHERE and ORDER BY 
+#             produces empty result
+#
 create table t1(a int, primary key (a)) ENGINE=MyISAM;
 insert into t1 values (10);
 create table t2 (a int primary key, b varchar(32), c int, unique key b(c, b)) ENGINE=MyISAM;
@@ -2669,6 +2950,10 @@
 a	a	b
 10	1	359
 drop table t1,t2;
+#
+# Bug #21853: assert failure for a grouping query with
+#             an ALL/ANY quantified subquery in HAVING 
+#
 CREATE TABLE t1 (                  
 field1 int NOT NULL,                 
 field2 int NOT NULL,                 
@@ -2705,6 +2990,10 @@
 1	1
 1	3
 DROP TABLE t1, t2;
+#
+# Bug #23478: not top-level IN subquery returning a non-empty result set
+#             with possible NULL values by index access from the outer query
+#
 CREATE TABLE t1(a int, INDEX (a)) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1), (3), (5), (7);
 INSERT INTO t1 VALUES (NULL);
@@ -2720,6 +3009,9 @@
 2	NULL
 3	1
 DROP TABLE t1,t2;
+#
+# Bug #11302: getObject() returns a String for a sub-query of type datetime
+#
 CREATE TABLE t1 (a DATETIME) ENGINE=MyISAM;
 INSERT INTO t1 VALUES ('1998-09-23'), ('2003-03-25');
 CREATE TABLE t2 ENGINE=MyISAM AS SELECT 
@@ -2737,6 +3029,10 @@
   `a` datetime DEFAULT NULL
 ) ENGINE=MyISAM
 DROP TABLE t1,t2,t3;
+#
+# Bug 24653: sorting by expressions containing subselects
+#            that return more than one row
+#
 CREATE TABLE t1 (a int) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (2), (4), (1), (3);
 CREATE TABLE t2 (b int, c int) ENGINE=MyISAM;
@@ -2811,6 +3107,10 @@
 (SELECT c FROM t2 WHERE c=a AND b > 1 ORDER BY b));
 ERROR 21000: Subquery returns more than 1 row
 DROP TABLE t1,t2;
+# End of 4.1 tests
+#
+#decimal-related tests
+#
 create table t1 (df decimal(5,1)) ENGINE=MyISAM;
 insert into t1 values(1.1);
 insert into t1 values(2.2);
@@ -2847,6 +3147,9 @@
 2.00
 4.00
 drop table t1;
+#
+# Test for bug #9338: lame substitution of c1 instead of c2 
+#
 CREATE table t1 ( c1 integer ) ENGINE=MyISAM;
 INSERT INTO t1 VALUES ( 1 );
 INSERT INTO t1 VALUES ( 2 );
@@ -2863,6 +3166,9 @@
 c1	c2
 1	1
 DROP TABLE t1,t2;
+#
+# Test for bug #9516: wrong evaluation of not_null_tables attribute in SQ 
+#
 CREATE TABLE t1 ( c1 integer ) ENGINE=MyISAM;
 INSERT INTO t1 VALUES ( 1 );
 INSERT INTO t1 VALUES ( 2 );
@@ -2882,6 +3188,10 @@
 2	NULL
 3	NULL
 DROP TABLE t1,t2,t3;
+#
+# Correct building of equal fields list (do not include outer
+# fields) (BUG#6384)
+#
 CREATE TABLE t1 (EMPNUM   CHAR(3)) ENGINE=MyISAM;
 CREATE TABLE t2 (EMPNUM   CHAR(3) ) ENGINE=MyISAM;
 INSERT INTO t1 VALUES ('E1'),('E2');
@@ -2895,6 +3205,9 @@
 EMPNUM
 E1
 DROP TABLE t1,t2;
+#
+# Test for bug #11487: range access in a subquery
+#
 CREATE TABLE t1(select_id BIGINT, values_id BIGINT) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1, 1);
 CREATE TABLE t2 (select_id BIGINT, values_id BIGINT, 
@@ -2916,12 +3229,17 @@
 values_id
 1
 DROP TABLE t1, t2;
+# BUG#11821 : Select from subselect using aggregate function on an enum
+# segfaults:
 create table t1 (fld enum('0','1')) ENGINE=MyISAM;
 insert into t1 values ('1');
 select * from (select max(fld) from t1) as foo;
 max(fld)
 1
 drop table t1;
+#
+# Test for bug #11762: subquery with an aggregate function in HAVING
+#
 CREATE TABLE t1 (a int, b int) ENGINE=MyISAM;
 CREATE TABLE t2 (c int, d int) ENGINE=MyISAM;
 CREATE TABLE t3 (e int) ENGINE=MyISAM;
@@ -3065,6 +3383,9 @@
 3	20
 4	40
 DROP TABLE t1,t2,t3;
+#
+# Test for bug #16603: GROUP BY in a row subquery with a quantifier 
+#                      when an index is defined on the grouping field
 CREATE TABLE t1 (a varchar(5), b varchar(10)) ENGINE=MyISAM;
 INSERT INTO t1 VALUES
 ('AAA', 5), ('BBB', 4), ('BBB', 1), ('CCC', 2),
@@ -3091,6 +3412,9 @@
 1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	9	Using where
 2	SUBQUERY	t1	ALL	NULL	NULL	NULL	NULL	9	Using temporary; Using filesort
 DROP TABLE t1;
+#
+# Bug#17366: Unchecked Item_int results in server crash
+#
 create table t1( f1 int,f2 int) ENGINE=MyISAM;
 insert into t1 values (1,1),(2,2);
 select tt.t from (select 'crash1' as t, f2 from t1) as tt left join t1 on tt.t = 'crash2' and tt.f2 = t1.f2 where tt.t = 'crash1';
@@ -3098,18 +3422,27 @@
 crash1
 crash1
 drop table t1;
+#
+# Bug #18306: server crash on delete using subquery.
+#
 create table t1 (c int, key(c)) ENGINE=MyISAM;
 insert into t1 values (1142477582), (1142455969);
 create table t2 (a int, b int) ENGINE=MyISAM;
 insert into t2 values (2, 1), (1, 0);
 delete from t1 where c <= 1140006215 and (select b from t2 where a = 2) = 1;
 drop table t1, t2;
+#
+# Bug#19077: A nested materialized derived table is used before being populated.
+#
 create table t1 (i int, j bigint) ENGINE=MyISAM;
 insert into t1 values (1, 2), (2, 2), (3, 2);
 select * from (select min(i) from t1 where j=(select * from (select min(j) from t1) t2)) t3;
 min(i)
 1
 drop table t1;
+# 
+# Bug#19700: subselect returning BIGINT always returned it as SIGNED
+#
 CREATE TABLE t1 (i BIGINT) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (10000000000000000);
 INSERT INTO t1 VALUES (1);
@@ -3131,6 +3464,9 @@
 10000000000000000
 DROP TABLE t1;
 DROP TABLE t2;
+# 
+# Bug#20519: subselect with LIMIT M, N
+#
 CREATE TABLE t1 (
 id bigint NOT NULL auto_increment,
 name varchar(255) NOT NULL,
@@ -3176,6 +3512,9 @@
 2	Joe	2006-04-20	2006-04-06
 3	Frank	2006-04-13	NULL
 DROP TABLE t1,t2;
+#
+# Bug#20869: subselect with range access by DESC
+#
 CREATE TABLE t1 (
 i1 int NOT NULL default '0',
 i2 int NOT NULL default '0',
@@ -3212,6 +3551,10 @@
 i1	i2	t	i1	i2	t
 24	1	2005-05-27 12:40:30	24	1	2006-06-20 12:29:40
 DROP TABLE t1, t2;
+#
+# Bug#14654 : Cannot select from the same table twice within a UNION
+# statement 
+#
 CREATE TABLE t1 (i INT) ENGINE=MyISAM;
 (SELECT i FROM t1) UNION (SELECT i FROM t1);
 i
@@ -3221,9 +3564,11 @@
 (SELECT i FROM t1)
 );
 i
+#TODO:not supported
 SELECT * FROM t1 
 WHERE NOT EXISTS (((SELECT i FROM t1) UNION (SELECT i FROM t1)));
 ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your Drizzle server version for the right syntax to use near 'UNION (SELECT i FROM t1)))' at line 1
+#TODO:not supported
 explain select ((select t11.i from t1 t11) union (select t12.i from t1 t12))
 from t1;
 ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your Drizzle server version for the right syntax to use near 'union (select t12.i from t1 t12))
@@ -3236,6 +3581,9 @@
 3	UNION	NULL	NULL	NULL	NULL	NULL	NULL	NULL	no matching row in const table
 NULL	UNION RESULT	<union2,3>	ALL	NULL	NULL	NULL	NULL	NULL	
 DROP TABLE t1;
+#
+# Bug #21540: Subqueries with no from and aggregate functions return 
+#              wrong results
 CREATE TABLE t1 (a INT, b INT) ENGINE=MyISAM;
 CREATE TABLE t2 (a INT) ENGINE=MyISAM;
 INSERT INTO t2 values (1);
@@ -3276,6 +3624,10 @@
 2
 2
 DROP TABLE t1,t2;
+#
+# Bug #21727: Correlated subquery that requires filesort:
+#             slow with big sort_buffer_size 
+#
 CREATE TABLE t1 (a int, b int auto_increment, PRIMARY KEY (b)) ENGINE=MyISAM;
 CREATE TABLE t2 (x int auto_increment, y int, z int,
 PRIMARY KEY (x), FOREIGN KEY (y) REFERENCES t1 (b)) ENGINE=MyISAM;
@@ -3294,6 +3646,10 @@
 COUNT(*)
 3000
 DROP TABLE t2,t1;
+#
+# Bug #25219: EXIST subquery with UNION over a mix of
+#             correlated and uncorrelated selects
+#
 CREATE TABLE t1 (id char(4) PRIMARY KEY, c int) ENGINE=MyISAM;
 CREATE TABLE t2 (c int) ENGINE=MyISAM;
 INSERT INTO t1 VALUES ('aa', 1);
@@ -3327,6 +3683,9 @@
 cc	3
 dd	1
 DROP TABLE t1,t2,t3;
+#
+# Bug#21904 (parser problem when using IN with a double "(())")
+#
 DROP TABLE IF EXISTS t1;
 DROP TABLE IF EXISTS t2;
 DROP TABLE IF EXISTS t1xt2;
@@ -3345,6 +3704,7 @@
 INSERT INTO t1 VALUES (1, 'a'), (2, 'b'), (3, 'c'), (4, 'd');
 INSERT INTO t2 VALUES (2, 'bb'), (3, 'cc'), (4, 'dd'), (12, 'aa');
 INSERT INTO t1xt2 VALUES (2, 2), (3, 3), (4, 4);
+# subselect returns 0 rows
 SELECT DISTINCT t1.id_1 FROM t1 WHERE
 (12 IN (SELECT t1xt2.id_2 FROM t1xt2 WHERE t1.id_1 = t1xt2.id_1));
 id_1
@@ -3376,6 +3736,7 @@
 3
 4
 insert INTO t1xt2 VALUES (1, 12);
+# subselect returns 1 row
 SELECT DISTINCT t1.id_1 FROM t1 WHERE
 (12 IN (SELECT t1xt2.id_2 FROM t1xt2 WHERE t1.id_1 = t1xt2.id_1));
 id_1
@@ -3407,6 +3768,7 @@
 3
 4
 insert INTO t1xt2 VALUES (2, 12);
+# subselect returns more than 1 row
 SELECT DISTINCT t1.id_1 FROM t1 WHERE
 (12 IN (SELECT t1xt2.id_2 FROM t1xt2 WHERE t1.id_1 = t1xt2.id_1));
 id_1
@@ -3440,6 +3802,9 @@
 DROP TABLE t1;
 DROP TABLE t2;
 DROP TABLE t1xt2;
+#
+# Bug #26728: derived table with concatanation of literals in select list
+#  
 CREATE TABLE t1 (a int) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (3), (1), (2);
 SELECT 'this is ' 'a test.' AS col1, a AS col2 FROM t1;
@@ -3453,6 +3818,9 @@
 this is a test.	1
 this is a test.	2
 DROP table t1;
+#
+# Bug #27257: COUNT(*) aggregated in outer query
+#  
 CREATE TABLE t1 (a int, b int) ENGINE=MyISAM;
 CREATE TABLE t2 (m int, n int) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (2,2), (2,2), (3,3), (3,3), (3,3), (4,4);
@@ -3478,6 +3846,9 @@
 2	2
 3	3
 DROP TABLE t1,t2;
+#
+# Bug #27229: GROUP_CONCAT in subselect with COUNT() as an argument 
+#  
 CREATE TABLE t1 (a int, b int) ENGINE=MyISAM;
 CREATE TABLE t2 (m int, n int) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (2,2), (2,2), (3,3), (3,3), (3,3), (4,4);
@@ -3497,6 +3868,9 @@
 3	3	4
 1	4	2,2
 DROP table t1,t2;
+#
+# Bug#27321: Wrong subquery result in a grouping select
+#
 CREATE TABLE t1 (a int, b INT, d INT, c CHAR(10) NOT NULL, PRIMARY KEY (a, b)) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1,1,0,'a'), (1,2,0,'b'), (1,3,0,'c'), (1,4,0,'d'),
 (1,5,0,'e'), (2,1,0,'f'), (2,2,0,'g'), (2,3,0,'h'), (3,4,0,'i'), (3,3,0,'j'),
@@ -3562,6 +3936,10 @@
 2	o
 3	p
 DROP TABLE t1;
+#
+# Bug #27363: nested aggregates in outer, subquery / sum(select
+# count(outer))
+#
 CREATE TABLE t1 (a INT) ENGINE=MyISAM;
 INSERT INTO t1 values (1),(1),(1),(1);
 CREATE TABLE t2 (x INT) ENGINE=MyISAM;
@@ -3579,6 +3957,9 @@
 FROM t1;
 ERROR HY000: Invalid use of group function
 DROP TABLE t1,t2;
+#
+# Bug #27807: Server crash when executing subquery with EXPLAIN
+#  
 CREATE TABLE t1 (a int, b int, KEY (a)) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1,1),(2,1);
 EXPLAIN SELECT 1 FROM t1 WHERE a = (SELECT COUNT(*) FROM t1 GROUP BY b);
@@ -3586,6 +3967,9 @@
 1	PRIMARY	t1	ref	a	a	5	const	1	Using where; Using index
 2	SUBQUERY	t1	ALL	NULL	NULL	NULL	NULL	2	Using temporary; Using filesort
 DROP TABLE t1;
+#
+# Bug #28377: grouping query with a correlated subquery in WHERE condition
+#  
 CREATE TABLE t1 (id int NOT NULL, st CHAR(2), INDEX idx(id)) ENGINE=MyISAM;
 INSERT INTO t1 VALUES
 (3,'FL'), (2,'GA'), (4,'FL'), (1,'GA'), (5,'NY'), (7,'FL'), (6,'NY');
@@ -3616,6 +4000,10 @@
 2	GA
 4	FL
 DROP TABLE t1,t2;
+#
+# Bug #28728: crash with EXPLAIN EXTENDED for a query with a derived table
+#             over a grouping subselect
+# 
 CREATE TABLE t1 (a int) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1), (2);
 EXPLAIN EXTENDED
@@ -3626,6 +4014,9 @@
 Warnings:
 Note	1003	select `res`.`count(*)` AS `count(*)` from (select count(0) AS `count(*)` from `test`.`t1` group by `test`.`t1`.`a`) `res`
 DROP TABLE t1;
+#
+# Bug #28811: crash for query containing subquery with ORDER BY and LIMIT 1 
+#
 CREATE TABLE t1 (
 a varchar(255) default NULL,
 b timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
@@ -3654,26 +4045,35 @@
 1
 1
 DROP TABLE t1,t2;
+#
+# Bug #27333: subquery grouped for aggregate of outer query / no aggregate
+# of subquery
+#
 CREATE TABLE t1 (a INTEGER, b INTEGER) ENGINE=MyISAM;
 CREATE TABLE t2 (x INTEGER) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1,11), (2,22), (2,22);
 INSERT INTO t2 VALUES (1), (2);
+# wasn't failing, but should
 SELECT a, COUNT(b), (SELECT COUNT(b) FROM t2) FROM t1 GROUP BY a;
 ERROR 21000: Subquery returns more than 1 row
+# fails as it should
 SELECT a, COUNT(b), (SELECT COUNT(b)+0 FROM t2) FROM t1 GROUP BY a;
 ERROR 21000: Subquery returns more than 1 row
 SELECT (SELECT SUM(t1.a)/AVG(t2.x) FROM t2) FROM t1;
 (SELECT SUM(t1.a)/AVG(t2.x) FROM t2)
 3.3333
 DROP TABLE t1,t2;
+# second test case from 27333
 CREATE TABLE t1 (a INT, b INT) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1, 2), (1,3), (1,4), (2,1), (2,2);
+# returns no rows, when it should
 SELECT a1.a, COUNT(*) FROM t1 a1 WHERE a1.a = 1
 AND EXISTS( SELECT a2.a FROM t1 a2 WHERE a2.a = a1.a)
 GROUP BY a1.a;
 a	COUNT(*)
 1	3
 DROP TABLE t1;
+#test cases from 29297
 CREATE TABLE t1 (a INT) ENGINE=MyISAM;
 CREATE TABLE t2 (a INT) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1),(2);
@@ -3687,6 +4087,9 @@
 (SELECT SUM(t1.a) FROM t2 WHERE a=1)
 3
 DROP TABLE t1,t2;
+#
+# Bug #31884: Assertion + crash in subquery in the SELECT clause.
+#
 CREATE TABLE t1 (a1 INT, a2 INT) ENGINE=MyISAM;
 CREATE TABLE t2 (b1 INT, b2 INT) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (100, 200);
@@ -3698,6 +4101,9 @@
 0
 0
 DROP TABLE t1, t2;
+#
+# Bug #30788: Inconsistent retrieval of char/varchar
+#
 CREATE TABLE t1 (a CHAR(1), b VARCHAR(10)) ENGINE=MyISAM;
 INSERT INTO t1 VALUES ('a', 'aa');
 INSERT INTO t1 VALUES ('a', 'aaa');
@@ -3729,6 +4135,10 @@
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1 WHERE LENGTH(a)<500);
 a	b
 DROP TABLE t1,t2;
+#
+# Bug #32400: Complex SELECT query returns correct result only on some
+# occasions
+#
 CREATE TABLE t1(a INT, b INT) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1,1), (1,2), (2,3), (2,4);
 EXPLAIN 
@@ -3754,6 +4164,9 @@
 1	2
 2	4
 DROP TABLE t1;
+#
+# Bug #32036: EXISTS within a WHERE clause with a UNION crashes MySQL 5.122
+#
 CREATE TABLE t1 (a INT) ENGINE=MyISAM;
 CREATE TABLE t2 (a INT) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1),(2);
@@ -3783,6 +4196,9 @@
 Note	1276	Field or reference 'test.t1.a' of SELECT #3 was resolved in SELECT #1
 Note	1003	select 2 AS `2` from `test`.`t1` where exists((select 1 AS `1` from `test`.`t2` where (`test`.`t1`.`a` = `test`.`t2`.`a`)) union (select 1 AS `1` from `test`.`t2` where (`test`.`t1`.`a` = `test`.`t2`.`a`)))
 DROP TABLE t1,t2;
+#
+# BUG#33794 "MySQL crashes executing specific query on specific dump"
+#
 CREATE TABLE t4 (
 f7 varchar(32) collate utf8_bin NOT NULL default '',
 f10 varchar(32) collate utf8_bin default NULL,
@@ -3832,10 +4248,14 @@
 2	NULL	NULL
 DROP TABLE t1, t2, t3, t4;
 End of 5.0 tests.
+#
+#  Test [NOT] IN truth table (both as top-level and general predicate).
+#
 create table t_out (subcase char(3),
 a1 char(2), b1 char(2), c1 char(2)) ENGINE=MyISAM;
 create table t_in  (a2 char(2), b2 char(2), c2 char(2)) ENGINE=MyISAM;
 insert into t_out values ('A.1','2a', NULL, '2a');
+#------------------------- A.2 - impossible
 insert into t_out values ('A.3', '2a', NULL, '2a');
 insert into t_out values ('A.4', '2a', NULL, 'xx');
 insert into t_out values ('B.1', '2a', '2a', '2a');
@@ -3935,6 +4355,7 @@
 NOT((a1, b1, c1) IN (select * from t_in));
 not_pred_in
 F
+# test non-top level result indirectly
 select case when count(*) > 0 then 'N' else 'wrong result' end as pred_in from t_out
 where subcase = 'A.3' and
 ((a1, b1, c1) IN (select * from t_in)) is NULL and
@@ -4005,6 +4426,7 @@
 NOT((a1, b1, c1) IN (select * from t_in));
 not_pred_in
 F
+# test non-top level result indirectly
 select case when count(*) > 0 then 'N' else 'wrong result' end as pred_in from t_out
 where subcase = 'B.3' and
 ((a1, b1, c1) IN (select * from t_in)) is NULL and
@@ -4029,12 +4451,18 @@
 T
 drop table t_out;
 drop table t_in;
+#
+# Bug#20835 (literal string with =any values)
+#
 CREATE TABLE t1 (s1 char(1)) ENGINE=MyISAM;
 INSERT INTO t1 VALUES ('a');
 SELECT * FROM t1 WHERE 'a' = ANY (SELECT s1 FROM t1);
 s1
 a
 DROP TABLE t1;
+#
+# Bug#33204: INTO is allowed in subselect, causing inconsistent results
+#
 CREATE TABLE t1( a INT ) ENGINE=MyISAM;
 INSERT INTO t1 VALUES (1),(2);
 CREATE TABLE t2( a INT, b INT ) ENGINE=MyISAM;
@@ -4088,6 +4516,8 @@
 a
 1
 2
+# This was not allowed previously. Possibly, it should be allowed on the future.
+# For now, the intent is to keep the fix as non-intrusive as possible.
 SELECT * FROM ((SELECT 1 a) UNION SELECT 1 a);
 ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your Drizzle server version for the right syntax to use near ')' at line 1
 SELECT * FROM (SELECT 1 a UNION (SELECT 1 a)) alias;
@@ -4126,6 +4556,11 @@
 SELECT * FROM (SELECT 1 a UNION SELECT 1 a ORDER BY a LIMIT 1) t1a;
 a
 1
+# Test of rule
+# table_factor:  '(' get_select_lex query_expression_body ')' opt_table_alias
+# UNION should not be allowed inside the parentheses, nor should
+# aliases after.
+# 
 SELECT * FROM t1 JOIN  (SELECT 1 UNION SELECT 1) alias ON 1;
 a	1
 1	1
@@ -4176,6 +4611,8 @@
 a	a
 1	1
 2	1
+# For the join, TABLE_LIST::select_lex == NULL
+# Check that we handle this.
 SELECT * FROM (t1 JOIN (SELECT 1) t1a1 ON 1) t1a2;
 ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your Drizzle server version for the right syntax to use near 't1a2' at line 1
 SELECT * FROM t1 WHERE a = ALL ( SELECT 1 );
@@ -4223,6 +4660,7 @@
 ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your Drizzle server version for the right syntax to use near 'INTO OUTFILE 'file' )' at line 1
 SELECT ( SELECT 1 UNION SELECT 1 INTO DUMPFILE 'file' );
 ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your Drizzle server version for the right syntax to use near 'INTO DUMPFILE 'file' )' at line 1
+# Make sure context is popped when we leave the nested select
 SELECT ( SELECT a FROM t1 WHERE a = 1 ), a FROM t1;
 ( SELECT a FROM t1 WHERE a = 1 )	a
 1	1
@@ -4231,8 +4669,10 @@
 ( SELECT a FROM t1 WHERE a = 1 UNION SELECT 1 )	a
 1	1
 1	2
+# Make sure we have feature F561 (see .yy file)
 SELECT * FROM t2 WHERE (a, b) IN (SELECT a, b FROM t2);
 a	b
+# Make sure the parser does not allow nested UNIONs anywhere
 SELECT 1 UNION ( SELECT 1 UNION SELECT 1 );
 ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your Drizzle server version for the right syntax to use near 'UNION SELECT 1 )' at line 1
 ( SELECT 1 UNION SELECT 1 ) UNION SELECT 1;

